<?php
/*
Plugin Name: RIYUK
Plugin URI: http://www.riyuk.de/wp
Description: Shortens every Post with Bitly. Youtube scroller integration like Facebook.
Version: 0.1.3
Author: Gerrit 'riyuk' Boettcher
Author URI: http://www.riyuk.de
License: GPL2
*/

if( !defined( 'R_PLUGIN_DIR' ) ) define( 'R_PLUGIN_DIR', dirname( __FILE__ ) . DIRECTORY_SEPARATOR );


// load class
require_once( R_PLUGIN_DIR . 'rytube.php' );

// frontend plugin laden
if( !is_admin() ) {
	
	if( is_string( get_option('ryt-youtube') ) && get_option('ryt-youtube') == '1' ) {
		// hook plugin into wp
		add_action( 'init', array( 'rYtube', 'actionInit' ) ); // zuständig dafür jquery in wp zu laden
		add_filter( 'the_content', array( 'rYtube', 'filterContent' ) );
	}
	
	$bitlyAccount = get_option( 'ryt-bitly-username' );
	$bitlyApi = get_option( 'ryt-bitly-api' );
	if( strlen( $bitlyAccount ) && strlen( $bitlyApi ) ) {
		// bit.ly
		add_action( 'the_post', array( 'rYtube', 'actionPost' ) );
	}
	
}

// admin interface hook
add_action( 'admin_menu', array( 'rYtube', 'actionAdmin' ) );
